/* Canale.java */

import java.util.HashMap;
import java.util.Vector;

/**
 * @author Fosco
 * 
 * Questa classe implementa il generico contenitore
 */
public class Canale {

  private Vector sottoscrittori = new Vector();

  public synchronized void addSubscriber(Sottoscrittore s) {
    //se il sottoscrittore non e' ancora stato registrato lo registro
    if (!sottoscrittori.contains(s))
      sottoscrittori.add(s);
  }


  public synchronized void removeSubscriber(Sottoscrittore s) {
    //se il sottoscrittore esiste lo de-sottoscrivo
    if (sottoscrittori.contains(s))
      sottoscrittori.removeElement(s);
  }

  /**
   * Metodo per la pubblicazione di messaggi da parte degli Editori.
   * 
   * Perche' questo metodo e' synchrnized? Cosa accade ai Sottoscrittori durante
   * l'esecuzione di questo metodo?
   *  
   */
  public synchronized void put(String msg) {
    if (sottoscrittori.isEmpty())
      return;
    else
      notifyMsg(msg);
  }

  /**
   * Metodo per la notifica dei messaggi ricevuti ai Sottoscrittori
   *  
   */
  private void notifyMsg(String msg) {
    /* recapito il msg a tutti i sottoscrittori */
    int tot = sottoscrittori.size();

    for (int i = 0; i < tot; i++) {
      Sottoscrittore sottoscrittoreIesimo = (Sottoscrittore) sottoscrittori
          .elementAt(i);
      sottoscrittoreIesimo.push(msg);
      sottoscrittoreIesimo.isMessage();
    }
  }
}